/*
tableSort.js v. 1.0
http://www.pescadosweb.com/
05/02/2005
*/



/******************************************
*  you can CONFIGURE the following vars:  *
*******************************************/

// this will make the sorting a bit slower, but maybe useful for you
var caseInsensitiveSort = false;

// cosmetic thing (you could add, eg, '<img src="up_arrow.gif">', or don't add nothig: '')
var ascendingAddon = ' &#x21D1;';

// same, but for descending order
var descendingAddon = ' &#8659;';

/*
If you setup the following as false, this script won't consider
the first row of the column as the clickable headers, and you
will be the responsible of calling the function "sortTable" as follow:

sortTable('tableID',0) //--> sort table "tableID" by first column
sortTable('tableID2',2) //--> sort table "tableID2" by third column
*/
var firstRowAreHeaders = true;

/******************************************
************  END CONFIGURE  **************
*******************************************/



var reverseOrder = false;
var lastSortedColumn = -1;

var tNames = []; // tables inited
var tHeaderss = []; // headers of inited tables

var rExp = /<[^>]*>/gi;


function init(tName) { // pass as parameter the ID of the table (original name)
	// store original values of this table's headers, and make 'em clickable
	if (firstRowAreHeaders) {
		t = document.getElementById(tName);
		
		tNames[tNames.length] = tName;
		tHeaders = [];
		for(i=0;i<t.rows[0].cells.length;i++){
			tHeader = t.rows[0].cells[i].innerHTML;
			tHeaders[tHeaders.length] = tHeader;
			t.rows[0].cells[i].innerHTML = '<a href="javascript:sortTable(\'' + tName + '\', ' + i + ')">' + tHeader + '</a>';
		}
		tHeaderss[tHeaderss.length] = tHeaders;
	}
}

function sortTable(tName, f) { // table name, field to sort by
	t = document.getElementById(tName); // get table to sort
	
	if (lastSortedColumn != f) { // regular sort if "new" clicked column header
		lastSortedColumn = f;
		reverseOrder = false;
	}
	
	if (firstRowAreHeaders) { // update headers only if requested
		firstRow = 1; // don't sort first row

		// update headers of this table with a little cosmetic thing
		if (reverseOrder){
			addOn = ascendingAddon;
		} else {
			addOn = descendingAddon;
		}
	
		// update headers
		for(i=0;i<tNames.length;i++){
			if(tNames[i]==tName){// found target table, use "i" in tHeaderss (stored default values)
				pullData = tHeaderss[i];
				for (x=0;x<pullData.length;x++){
					if (x == f) { // put here special char, this is the sort-field
						t.rows[0].cells[x].innerHTML = '<a href="javascript:sortTable(\'' + tName + '\', ' + x + ')">' + pullData[x] + '</a>' + addOn;
					} else {
						t.rows[0].cells[x].innerHTML = '<a href="javascript:sortTable(\'' + tName + '\', ' + x + ')">' + pullData[x] + '</a>';
					}
				}
				break;
			}
		}
	} else {
		firstRow = 0; // sort all rows
	}

	// create txt-array of rows-to-sort
	// ignore first row (concibed as clickable header) if needed

	txtArrayToSort = [];
	originalArray = [];
	
	for (i=firstRow;i<t.rows.length;i++){
		r = t.rows[i];
		tmpJoin = "";
		tmpOr = [];
		
		numColumns = r.cells.length;
		
		for (x=0;x<numColumns;x++){
			c = r.cells[x].innerHTML; // get contents of {row i, column x}
			// c: ignore HTML tags stripping via basic and unsafe regexp pattern
			if (x == f) tmpJoin = c.replace(rExp, ''); // I only need this field
			tmpOr[tmpOr.length] = c;
		}
		z = "000000" + i;
		z = z.substring(z.length - 6,z.length);
		
		txtArrayToSort.push(tmpJoin + '<' + z); // add field plus "safe" separator plus relative order in originalArray
		originalArray.push(tmpOr);
	}

	// now we have an array-of-strings to sort and a correspondent array-of-things
	// sort it!

	txtArrayToSort = txtArrayToSort.sort(compactSort);
	
	// re-create original table according to re-sorted txtArrayToSort
	for (i=0;i<txtArrayToSort.length;i++){
		orItemToReponer = txtArrayToSort[i];
		n = Number(orItemToReponer.substring(orItemToReponer.length - 6, orItemToReponer.length));
		
		for(x=0;x<numColumns;x++){
			t.rows[i+firstRow].cells[x].innerHTML = originalArray[n-firstRow][x];
		}
	}
	
	reverseOrder = (! reverseOrder);
}

function compactSort(x,y){
	x = x.substring(0,x.indexOf('<'));
	y = y.substring(0,y.indexOf('<'));
	if (! isNaN(Number(x)) && ! isNaN(Number(y))){ // both are numbers
		x = parseFloat(x);
		y = parseFloat(y);
	} else { // strings
		if (caseInsensitiveSort){
			x = x.toLowerCase();
			y = y.toLowerCase();
		}
	}
	if (reverseOrder){
		if (x>y) return -1;
		if (x<y) return 1;
	} else {
		if (x<y) return -1;
		if (x>y) return 1;
	}
	return 0;
}